package com.tinysine.tosrblue;

import java.util.ArrayList;
import java.util.Set;

import com.tinysine.tosrblue.R;
import com.tinysine.tosrblue.command.ATCommandOutput;
import com.tinysine.tosrblue.config.ATConfig;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.PreferenceActivity;
import android.preference.PreferenceScreen;
import android.widget.Toast;

public class ATConfigActivity  extends PreferenceActivity implements
OnPreferenceChangeListener{
	public static final String BLUETOOTH_LIST_KEY = "bluetooth_list_preference";
	public static final String UPLOAD_URL_KEY = "upload_url_preference";
	public static final String UPLOAD_DATA_KEY = "upload_data_preference";

	public static final String VEHICLE_ID_KEY = "vehicle_id_preference";
	
	public static final String IMPERIAL_UNITS_KEY = "imperial_units_preference";
	public static final String COMMANDS_SCREEN_KEY = "obd_commands_screen";
	public static final String ENABLE_GPS_KEY = "enable_gps_preference";

	public static final String CONFIG_READER_KEY = "reader_config_preference";
	
	public static final String SENDVIOCE_URL_KEY = "sendvioce_url_preference";
	public static final String RECEIVEVIOCE_URL_KEY = "receivevioce_url_preference";
	public static final String CARMATES_LIST_KEY = "carmates_list_preference";
	public static final String RECEIVE_DATA_KEY = "receive_data_preference";
	public static final String UPLOAD_PORT_KEY = "upload_port_preference";
	
	
	
	public static final String STRING_PREFIX = "string_prefix";
	public static final String STRING_SUFFIX = "string_suffix";
	public static final String   STRING_SUFFIX1 = "string_suffix1";
	public static final String   STRING_SUFFIX2 = "string_suffix2";
	
	public static final String UPDATE_PERIOD_KEY = "update_period_preference";
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		  addPreferencesFromResource(R.xml.preferences);

		ArrayList<CharSequence> pairedDeviceStrings = new ArrayList<CharSequence>();
		ArrayList<CharSequence> vals = new ArrayList<CharSequence>();
		ListPreference listPref = (ListPreference) getPreferenceScreen()
				.findPreference(BLUETOOTH_LIST_KEY);
//		String[] prefKeys = new String[] {
//				STRING_SUFFIX1,STRING_SUFFIX2};
//		for (String prefKey : prefKeys) {
//			EditTextPreference txtPref = (EditTextPreference) getPreferenceScreen()
//					.findPreference(prefKey);
//			txtPref.setOnPreferenceChangeListener(this);
//		}
		final BluetoothAdapter mBluetoothAdapter = BluetoothAdapter
				.getDefaultAdapter();
		if (mBluetoothAdapter == null) {
			listPref.setEntries(pairedDeviceStrings
					.toArray(new CharSequence[0]));
			listPref.setEntryValues(vals.toArray(new CharSequence[0]));
			return;
		}
		final Activity thisAct = this;// 	listPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
		listPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
			public boolean onPreferenceClick(Preference preference) {
				if (mBluetoothAdapter == null) {
					Toast.makeText(thisAct,
							"This device does not support bluetooth",
							Toast.LENGTH_LONG);
					return false;
				}
				return true;
			}
		});
		Set<BluetoothDevice> pairedDevices = mBluetoothAdapter
				.getBondedDevices();
		if (pairedDevices.size() > 0) {
			for (BluetoothDevice device : pairedDevices) {
				pairedDeviceStrings.add(device.getName() + "\n"
						+ device.getAddress());
				vals.add(device.getAddress());
			}
		}
		listPref.setEntries(pairedDeviceStrings.toArray(new CharSequence[0]));
		listPref.setEntryValues(vals.toArray(new CharSequence[0]));
		
		
		//  指令行
		ArrayList<ATCommandOutput> cmds = ATConfig.getCommands();
		PreferenceScreen cmdScr = (PreferenceScreen) getPreferenceScreen()
				.findPreference(COMMANDS_SCREEN_KEY);
		for (int i = 0; i < cmds.size(); i++) {
			ATCommandOutput cmd = cmds.get(i);
			CheckBoxPreference cpref = new CheckBoxPreference(this);
			cpref.setTitle(cmd.getATcommandDsc());
			cpref.setKey(cmd.getATcommandDsc());
			cpref.setChecked(true);
			cmdScr.addPreference(cpref);
		}


	}

//	public static int getUpdatePeriod(SharedPreferences prefs) {
//		String periodString = prefs.getString(
//				ATConfigActivity.UPDATE_PERIOD_KEY, "1");
//		int period = 1000;
//		try {
//			period = Integer.parseInt(periodString) * 1000;
//		} catch (Exception e) {
//		}
//		if (period <= 0) {
//			period = 250;
//		}
//		return period;
//	}
	

	public boolean onPreferenceChange(Preference preference, Object newValue) {
		// TODO Auto-generated method stub
		return false;
	}
	
	/*
	 * 返回所有的命令行
	 * */
	public static ArrayList<ATCommandOutput> getObdCommands(SharedPreferences prefs) {
		ArrayList<ATCommandOutput> cmds = ATConfig.getCommands();
		ArrayList<ATCommandOutput> ucmds = new ArrayList<ATCommandOutput>();
		for (int i = 0; i < cmds.size(); i++) {
			ATCommandOutput cmd = cmds.get(i);
			boolean selected = prefs.getBoolean(cmd.getATcommandDsc(), true);
			System.out.println("di "+i+" ge "+selected);
			if (selected) {
				ucmds.add(cmd);
			}
		}
		
		System.out.println( ucmds.size()+"daxiao");
		return ucmds;
	}
	
}
