package com.tinysine.tosrblue;

import java.sql.Date;
import java.text.NumberFormat;
import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.NotificationManager;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.InputFilter;
import android.text.InputType;
import android.text.TextUtils;
import android.text.method.PasswordTransformationMethod;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.tinysine.tosrblue.command.ATCommandOutput;
import com.tinysine.tosrblue.io.ATService;
import com.tinysine.tosrblue.io.ATServiceConnection;

public class Bluemd extends Activity implements OnCheckedChangeListener,
		OnTouchListener {
	/** Called when the activity is first created. */

	private Button[] relays;
	private boolean[] touchflag;
	private TextView tv_temp;
	private CheckBox cb_mode;

	private ProgressDialog pDialog;
	private boolean isVerify = false;
	private TextView tv_status;

	private ATServiceConnection serviceConn = null;
	private Intent serviceIntent = null;

	private boolean[] RelayBools = new boolean[8];
	private SharedPreferences preferences;
	public static final String PREFS_NAME = "MyPrefsFile";
	private boolean isCtemp = true;
	private SharedPreferences sp;

	private int status = Util.BT_DATA_PASSWORD;
	private boolean isBind = false;

	private Button btn_allon;
	private Button btn_alloff;
	
	public static boolean modeflg = true;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// Set up the window layout
		setContentView(R.layout.ac_main);
		sp = getSharedPreferences("name", MODE_PRIVATE);
		preferences = getSharedPreferences(PREFS_NAME, 0);
		tv_status = (TextView) findViewById(R.id.tv_stutas);
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		pDialog = new ProgressDialog(this);
		pDialog.setMessage("Verifying...");
		pDialog.setCancelable(false);
		if (mBluetoothAdapter == null) {
			finishDialogNoBluetooth();
			return;
		}
		serviceIntent = new Intent(this, ATService.class);
		serviceConn = new ATServiceConnection(this);
		isBind = bindService(serviceIntent, serviceConn,
				Context.BIND_AUTO_CREATE);

		relays = new Button[8];
		relays[0] = (Button) findViewById(R.id.relay1);
		relays[1] = (Button) findViewById(R.id.relay2);
		relays[2] = (Button) findViewById(R.id.relay3);
		relays[3] = (Button) findViewById(R.id.relay4);
		relays[4] = (Button) findViewById(R.id.relay5);
		relays[5] = (Button) findViewById(R.id.relay6);
		relays[6] = (Button) findViewById(R.id.relay7);
		relays[7] = (Button) findViewById(R.id.relay8);
		touchflag = new boolean[8];
		for (int i = 0; i < 8; i++) {
			touchflag[i] = true;
			relays[i].setOnTouchListener(this);
		}

		tv_temp = (TextView) findViewById(R.id.temp);
		registerReceiver(mHomeKeyEventReceiver, new IntentFilter(
				Intent.ACTION_CLOSE_SYSTEM_DIALOGS));
		cb_mode = (CheckBox) findViewById(R.id.cb_mode);
		cb_mode.setOnCheckedChangeListener(this);
		btn_allon = (Button) findViewById(R.id.btn_allon);
		btn_alloff = (Button) findViewById(R.id.btn_alloff);
		isVerify = false;
	}

	@Override
	public void onStart() {
		super.onStart();
		mEnablingBT = false;
	}

	private BluetoothAdapter mBluetoothAdapter = null;
	private boolean mEnablingBT = false;
	private static final int REQUEST_ENABLE_BT = 2;

	@Override
	public synchronized void onResume() {
		super.onResume();
		if (!mEnablingBT) {
			if ((mBluetoothAdapter != null) && (!mBluetoothAdapter.isEnabled())) {
				mEnablingBT = true;
				Intent enableIntent = new Intent(
						BluetoothAdapter.ACTION_REQUEST_ENABLE);
				startActivityForResult(enableIntent, REQUEST_ENABLE_BT);

			}
		}
		for (int index = 0; index < 8; index++) {
			relays[index].setText(sp.getString("name" + index, "Relay"
					+ (index + 1)));
		}
	}

	public void finishDialogNoBluetooth() {
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage(R.string.alert_dialog_no_bt)
				.setIcon(android.R.drawable.ic_dialog_info)
				.setTitle(R.string.app_name)
				.setCancelable(false)
				.setPositiveButton(R.string.alert_dialog_ok,
						new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int id) {
								finish();
							}
						});
		AlertDialog alert = builder.create();
		alert.show();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.option_menu, menu);
		return true;
	}

	// Intent request codes
	private static final int REQUEST_CONNECT_DEVICE = 1;
	public static final String DEVICE_NAME = "device_name";

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.connect:
			Intent serverIntent = new Intent(this, DeviceListActivity.class);
			startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
			return true;
		case R.id.preferences:
			mHandlerBT.sendEmptyMessage(Util.BT_EXIT);
			return true;
		case R.id.setting:
			Intent settingIntent = new Intent(this, SettingActivity.class);
			startActivity(settingIntent);
			return true;
		}
		return false;
	}

	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case REQUEST_CONNECT_DEVICE:
			// When DeviceListActivity returns with a device to connect
			if (resultCode == Activity.RESULT_OK) {
				// Get the device MAC address
				final String address = data.getExtras().getString(
						DeviceListActivity.EXTRA_DEVICE_ADDRESS);
				// Get the BLuetoothDevice object
				BluetoothDevice device = mBluetoothAdapter
						.getRemoteDevice(address);
				mConnectedDeviceName = data.getExtras().getString(DEVICE_NAME);

				AlertDialog.Builder builder = new AlertDialog.Builder(this);

				// Use an EditText view to get user input.
				final EditText input = new EditText(this);

				builder.setTitle("Device Name");
				builder.setMessage("Please input a new name");
				input.setText(device.getName());
				builder.setView(input);

				if (preferences.getString(device.getAddress(), null) == null) {
					builder.setPositiveButton("Save",
							new DialogInterface.OnClickListener() {
								@Override
								public void onClick(DialogInterface dialog,
										int whichButton) {
									mConnectedDeviceName = input.getText()
											.toString();
									preferences
											.edit()
											.putString(address,
													mConnectedDeviceName)
											.commit();
									live(address);

									return;
								}
							});
					builder.create().show();
				} else {
					live(address);
				}
			}
			break;

		case REQUEST_ENABLE_BT:
			if ((mBluetoothAdapter != null) && (!mBluetoothAdapter.isEnabled())) {
				finishDialogNoBluetooth();
			}
		}
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		unregisterReceiver(mHomeKeyEventReceiver);
	}

	private String mConnectedDeviceName = null;

	private int connectFLg = 0;
	private final Handler mHandlerBT = new Handler(new Handler.Callback() {

		@Override
		public boolean handleMessage(Message msg) {
			// TODO Auto-generated method stub

			switch (msg.what) {
			case Util.BT_STATE:
				switch (msg.arg1) {
				case Util.STATE_CONNECTED:
					tv_status.setText(R.string.title_connected_to);
					tv_status.append(Getname());
					connectFLg = 1;
					if (pDialog != null) {
						pDialog.cancel();
						;
					}
					if (!isVerify) {
						popEditPassword();
					}
					break;
				case Util.STATE_CONNECTING:
					tv_status.setText(R.string.title_connecting);
					connectFLg = 0;
					break;
				case Util.STATE_LISTEN:
					connectFLg = 0;
				case Util.STATE_NONE:
					tv_status.setText(R.string.title_not_connected);
					connectFLg = 0;
					break;
				}
				break;
			case 1:
				for (int i = 0; i < 8; i++) {
					System.out.println(RelayBools[i]);
				}
				break;
			case Util.BT_DATA:
				if (status == Util.BT_DATA_MODE) {
					if (msg.arg2 == 65) {
						cb_mode.setChecked(true);
					} else {
						cb_mode.setChecked(false);
					}
					if (sendModeThread != null && sendModeThread.isAlive()) {
						sendModeThread.Stop();
					}
					sendRelay();
				} else if (status == Util.BT_DATA_RELAY) {
					if (count == 0) {
						int relay = msg.arg2;
						count = 1;
						String result = bytesToHexToTwoString((byte) relay);
						if (result != null) {
							int length = result.length();
							result = reverseSort(result);
							for (int i = 0; i < length; i++) {
								if ("1".equals(result.substring(i, i + 1))) {
									RelayBools[i] = true;
								} else {
									RelayBools[i] = false;
								}
							}
							for (int j = length; j < 8; j++) {
								RelayBools[j] = false;
							}
							if (RelayBools[0]) {
								relays[0]
										.setBackgroundResource(R.drawable.btn_left_pressed);
							} else {
								relays[0]
										.setBackgroundResource(R.drawable.btn_left_normal);
							}
							if (RelayBools[1]) {
								relays[1]
										.setBackgroundResource(R.drawable.btn_middle_pressed);
							} else {
								relays[1]
										.setBackgroundResource(R.drawable.btn_middle_normal);
							}
							if (RelayBools[2]) {
								relays[2]
										.setBackgroundResource(R.drawable.btn_middle_pressed);
							} else {
								relays[2]
										.setBackgroundResource(R.drawable.btn_middle_normal);
							}
							if (RelayBools[3]) {
								relays[3]
										.setBackgroundResource(R.drawable.btn_right_pressed);
							} else {
								relays[3]
										.setBackgroundResource(R.drawable.btn_right_nromal);
							}
							if (RelayBools[4]) {
								relays[4]
										.setBackgroundResource(R.drawable.btn_left_pressed);
							} else {
								relays[4]
										.setBackgroundResource(R.drawable.btn_left_normal);
							}
							if (RelayBools[5]) {
								relays[5]
										.setBackgroundResource(R.drawable.btn_middle_pressed);
							} else {
								relays[5]
										.setBackgroundResource(R.drawable.btn_middle_normal);
							}
							if (RelayBools[6]) {
								relays[6]
										.setBackgroundResource(R.drawable.btn_middle_pressed);
							} else {
								relays[6]
										.setBackgroundResource(R.drawable.btn_middle_normal);
							}
							if (RelayBools[7]) {
								relays[7]
										.setBackgroundResource(R.drawable.btn_right_pressed);
							} else {
								relays[7]
										.setBackgroundResource(R.drawable.btn_right_nromal);
							}
						}
					} else if (count == 1) {
						count = 2;
					} else if (count == 2) {
						msb = (byte) msg.arg2;
						count = 3;
					} else if (count == 3) {
						byte lsb = (byte) msg.arg2;
						count = 0;
						if (msb == 0 && lsb == 0) {
							tv_temp.setText("NC");
						} else {
							int LSB = lsb < 0 ? lsb + 256 : lsb;
							double te = (msb * 255 + LSB) / 16.0;
							NumberFormat format = NumberFormat
									.getNumberInstance();
							format.setMaximumFractionDigits(2);
							if (isCtemp) {
								tv_temp.setText(format.format(te) + "℃");
							} else {
								double te1 = te * 9 / 5 + 32;
								tv_temp.setText(format.format(te1) + "℉");
							}
						}
					}
				} else if (status == Util.BT_DATA_PASSWORD) {
					int password = msg.arg2;
					if (pDialog != null) {
						pDialog.cancel();
					}
					if (password == 1) {
						isVerify = true;
						sendMode();
						Toast.makeText(Bluemd.this, "Verify successful!", Toast.LENGTH_SHORT)
								.show();
					} else {
						Toast.makeText(Bluemd.this, "Verify failed,password incrrect! Please reset your board!",
								Toast.LENGTH_SHORT).show();
						isVerify = false;
						popEditPassword();
					}
				}
				break;
			case Util.BT_EXIT:
				exitApp();
			}
			return false;
		}
	});
	private int count = 0;
	private byte msb = 0;
	public ArrayList<Byte> tmpBuffer = new ArrayList<Byte>();

	public synchronized String bytesToHexToTwoString(Byte buffer) {
		StringBuilder stringBuilder = new StringBuilder("");
		if (buffer == null) {
			return null;
		}
		int v = buffer & 0xFF;
		String hv = Integer.toHexString(v);
		if (hv.length() < 2) {
			stringBuilder.append(0);
		}
		stringBuilder.append(hv);
		int c = Integer.parseInt(stringBuilder.toString(), 16);
		return Integer.toBinaryString(c);
	}

	public void liveData(ATCommandOutput cmd) {
		if (!serviceConn.isRunning()) {
			SharedPreferences preferences = getSharedPreferences("device", 0);
			String address = preferences.getString("address", "not");
			connectFLg = 0;
			isVerify = false;
			status = Util.BT_DATA_PASSWORD;
			if (sendModeThread != null) {
				sendModeThread.Stop();
			}
			if (sendRelayThread != null) {
				sendRelayThread.Stop();
			}
			if (address.equals("not")) {
				serviceConn.getService().startService(this, "", mHandlerBT);
				Intent serverIntent = new Intent(this, DeviceListActivity.class);
				startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
			} else {
				serviceConn.getService().startService(this, "", mHandlerBT);
				live(address);
			}
		} else {
			serviceConn.getService().Send(cmd);
		}

	}

	public void live(String address) {
		if (serviceConn.isRunning()) {
			serviceConn.getService().stopService();
			serviceConn.getService().startService(this, address, mHandlerBT);
		} else {
			serviceConn.getService().startService(this, address, mHandlerBT);
		}

	}

	public String GetnameName() {
		if (serviceConn.isRunning()) {
			return serviceConn.getService().getDevname();
		} else {
			return "null";
		}
	}

	public String Getname() {
		if (serviceConn.isRunning()) {
			String tmpString = preferences.getString(serviceConn.getService()
					.getDevAddress(), null);
			if (tmpString != null) {
				return tmpString;

			} else {
				return serviceConn.getService().getDevname();

			}
		} else {
			return "null";
		}
	}

	public static String reverseSort(String str) {
		String str2 = "";
		for (int i = str.length() - 1; i > -1; i--) {
			str2 += String.valueOf(str.charAt(i));
		}
		return str2;
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setMessage("Do you exit program?")
					.setIcon(android.R.drawable.ic_dialog_info)
					.setTitle(R.string.app_name)
					.setCancelable(false)
					.setPositiveButton("Yes",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {
									NotificationManager noManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
									noManager.cancelAll();
									Message msg = new Message();
									msg.what = Util.BT_EXIT;
									mHandlerBT.sendMessageDelayed(msg, 600);
								}
							})
					.setNegativeButton("No",
							new DialogInterface.OnClickListener() {
								@Override
								public void onClick(DialogInterface dialog,
										int which) {
									// TODO Auto-generated method stub

								}

							});
			AlertDialog alert = builder.create();
			alert.show();
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	private BroadcastReceiver mHomeKeyEventReceiver = new BroadcastReceiver() {
		String SYSTEM_REASON = "reason";
		String SYSTEM_HOME_KEY = "homekey";

		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			if (action.equals(Intent.ACTION_CLOSE_SYSTEM_DIALOGS)) {
				String reason = intent.getStringExtra(SYSTEM_REASON);
				if (TextUtils.equals(reason, SYSTEM_HOME_KEY)) {
					isVerify = false;
					connectFLg = 0;
					serviceConn.getService().stopService();
					if (sendRelayThread != null && sendRelayThread.isAlive()) {
						sendRelayThread.Stop();
					}
				}
			}
		}
	};

	private void exitApp() {
		if (isBind) {
			unbindService(serviceConn);
			isBind = false;
		}
		if (sendRelayThread != null && sendRelayThread.isAlive()) {
			sendRelayThread.Stop();
		}
		Bluemd.this.finish();
	}

	public static boolean dateCompare(Date dat1, Date dat2) {
		boolean dateComPareFlag = true;
		if (dat2.compareTo(dat1) != 1) {
			dateComPareFlag = false; //
		}
		return dateComPareFlag;
	}

	@Override
	public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
		// TODO Auto-generated method stub
		if (connectFLg == 1 && !isVerify) {
			popEditPassword();
		}
		if (arg1) {
			btn_alloff.setEnabled(true);
			btn_allon.setEnabled(true);
			liveData(new ATCommandOutput("41", "", ""));
		} else {
			btn_alloff.setEnabled(false);
			btn_allon.setEnabled(false);
			liveData(new ATCommandOutput("42", "", ""));
		}
	}

	public void allOn(View view) {
		if (connectFLg == 1 && !isVerify) {
			popEditPassword();
			return;
		}
		liveData(new ATCommandOutput("64", "", ""));
	}

	public void allOff(View view) {
		if (connectFLg == 1 && !isVerify) {
			popEditPassword();
			return;
		}
		liveData(new ATCommandOutput("6E", "", ""));
	}

	public void onTempSwitch(View v) {
		isCtemp = !isCtemp;
	}

	@Override
	public boolean onTouch(View arg0, MotionEvent arg1) {
		// TODO Auto-generated method stub
		switch (arg0.getId()) {
		case R.id.relay1: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;                                                 //normal模式，发送状态查询指令
					if (RelayBools[0]) {
						liveData(new ATCommandOutput("6F", "", ""));
					} else {
						liveData(new ATCommandOutput("65", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[0] = true;
						modeflg = false;                                            //暂停发送状态查询指令
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while(touchflag[0]) {
									try {
										Thread.sleep(250);                          //延时消抖
										if (touchflag[0]) {
											liveData(new ATCommandOutput("65", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[0]
								.setBackgroundResource(R.drawable.btn_left_pressed);//模拟按键按下
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[0] = false;
					liveData(new ATCommandOutput("6F", "", ""));
					relays[0]
							.setBackgroundResource(R.drawable.btn_left_normal);   
					modeflg = true;                                                 //恢复发送状态查询指令
				}
			}
				break;
			}
		}
			break;
		case R.id.relay2: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;                                                 //normal模式，发送状态查询指令
					if (RelayBools[1]) {
						liveData(new ATCommandOutput("70", "", ""));
					} else {
						liveData(new ATCommandOutput("66", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[1] = true;
						modeflg = false;                                            //暂停发送状态查询指令
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[1]) {
									try {
										Thread.sleep(250);
										if (touchflag[1]) {
											liveData(new ATCommandOutput("66", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[1]
								.setBackgroundResource(R.drawable.btn_middle_pressed);//模拟按键按下
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[1] = false;
					liveData(new ATCommandOutput("70", "", ""));
					relays[1]
							.setBackgroundResource(R.drawable.btn_middle_normal);
					modeflg = true;                                                 //恢复发送状态查询指令
				}
			}
				break;
			}
		}
			break;
		case R.id.relay3: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					if (RelayBools[2]) {
						modeflg = true;                                             //normal模式，发送状态查询指令
						liveData(new ATCommandOutput("71", "", ""));
					} else {
						liveData(new ATCommandOutput("67", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[2] = true;
						modeflg = false;                                            //暂停发送状态查询指令
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[2]) {
									try {
										Thread.sleep(250);
										if (touchflag[2]) {
											liveData(new ATCommandOutput("67", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[2]
								.setBackgroundResource(R.drawable.btn_middle_pressed);//模拟按键按下
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[2] = false;
					liveData(new ATCommandOutput("71", "", ""));
					relays[2]
							.setBackgroundResource(R.drawable.btn_middle_normal);   
					modeflg = true;                                                 //恢复发送状态查询指令
				}
			}
				break;
			}
		}
			break;
		case R.id.relay4: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;                                             //normal模式，发送状态查询指令
					if (RelayBools[3]) {
						liveData(new ATCommandOutput("72", "", ""));
					} else {
						liveData(new ATCommandOutput("68", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[3] = true;
						modeflg = false;                                        //暂停发送状态查询指令
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[3]) {
									try {
										Thread.sleep(250);
										if (touchflag[3]) {
											liveData(new ATCommandOutput("68", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[3]
								.setBackgroundResource(R.drawable.btn_right_pressed);
						
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[3] = false;
					liveData(new ATCommandOutput("72", "", ""));
					relays[3]
							.setBackgroundResource(R.drawable.btn_right_nromal);
					modeflg = true;                                                 //恢复发送状态查询指令
				}
			}
				break;
			}
		}
			break;
		case R.id.relay5: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;  
					if (RelayBools[4]) {
						liveData(new ATCommandOutput("73", "", ""));
					} else {
						liveData(new ATCommandOutput("69", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[4] = true;
						modeflg = false;  
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[4]) {
									try {
										Thread.sleep(250);
										if (touchflag[4]) {
											liveData(new ATCommandOutput("69", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[4]
								.setBackgroundResource(R.drawable.btn_left_pressed);//模拟按键按下
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[4] = false;
					liveData(new ATCommandOutput("73", "", ""));
					relays[4]
							.setBackgroundResource(R.drawable.btn_left_normal);
					modeflg = true;  
				}
			}
				break;
			}
		}
			break;
		case R.id.relay6: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true; 
					if (RelayBools[5]) {
						liveData(new ATCommandOutput("74", "", ""));
					} else {
						liveData(new ATCommandOutput("6A", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[5] = true;
						modeflg = false; 
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[5]) {
									try {
										Thread.sleep(250);
										if (touchflag[5]) {
											liveData(new ATCommandOutput("6A", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[5]
								.setBackgroundResource(R.drawable.btn_middle_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[5] = false;
					liveData(new ATCommandOutput("74", "", ""));
					relays[5]
							.setBackgroundResource(R.drawable.btn_middle_normal);
					modeflg = true; 
				}
			}
				break;
			}
		}
			break;
		case R.id.relay7: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;
					if (RelayBools[6]) {
						liveData(new ATCommandOutput("75", "", ""));
					} else {
						liveData(new ATCommandOutput("6B", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[6] = true;
						modeflg = false;
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[6]) {
									try {
										Thread.sleep(250);
										if (touchflag[6]) {
											liveData(new ATCommandOutput("6B", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[6]
								.setBackgroundResource(R.drawable.btn_middle_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[6] = false;
					liveData(new ATCommandOutput("75", "", ""));
					relays[6]
							.setBackgroundResource(R.drawable.btn_middle_normal);
					modeflg = true;
				}
			}
				break;
			}
		}
			break;
		case R.id.relay8: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;
					if (RelayBools[7]) {
						liveData(new ATCommandOutput("76", "", ""));
					} else {
						liveData(new ATCommandOutput("6C", "", ""));
					}
				} else {
					liveData(new ATCommandOutput("", "", ""));
					if (serviceConn.isRunning()) {
						touchflag[7] = true;
						modeflg = false;
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[7]) {
									try {
										Thread.sleep(250);
										if (touchflag[7]) {
											liveData(new ATCommandOutput("6C", "", ""));
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[7]
								.setBackgroundResource(R.drawable.btn_right_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && serviceConn.isRunning()) {
					touchflag[7] = false;
					liveData(new ATCommandOutput("76", "", ""));
					relays[7]
							.setBackgroundResource(R.drawable.btn_right_nromal);
					modeflg = true;
					
				}
			}
				break;
			}
		}
			break;
		}
		return false;
	}

	private class SendAndRec extends Thread {
		boolean senflg = true;

		@Override
		public void run() {
			// TODO Auto-generated method stub
			super.run();
			while (senflg) {
				if(modeflg){                                       //增加模式判断，只在nomal模式下发送状态查询指令
					liveData(new ATCommandOutput("44", "", ""));
					try {
						sleep(400);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		}

		public void Stop() {
			senflg = false;
		}
	}

	private void sendPassword(String pasword) {
		status = Util.BT_DATA_PASSWORD;
		liveData(new ATCommandOutput(pasword, "", ""));
	}

	private SendModeThread sendModeThread = null;

	private void sendMode() {
		status = Util.BT_DATA_MODE;
		sendModeThread = new SendModeThread();
		sendModeThread.start();
	}

	private class SendModeThread extends Thread {
		boolean isFlag = true;

		@Override
		public void run() {
			// TODO Auto-generated method stub
			while (isFlag) {
				liveData(new ATCommandOutput("43", "", ""));
				try {
					sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			super.run();
		}

		public void Stop() {
			isFlag = false;
		}
	}

	private SendAndRec sendRelayThread;

	private void sendRelay() {
		status = Util.BT_DATA_RELAY;
		sendRelayThread = new SendAndRec();
		sendRelayThread.start();
	}

	private void popEditPassword() {
		final EditText eText = new EditText(this);
		InputFilter[] filters = { new InputFilter.LengthFilter(6) };
		eText.setFilters(filters);
		eText.setInputType(InputType.TYPE_CLASS_NUMBER);
		eText.setTransformationMethod(PasswordTransformationMethod.getInstance());
		new AlertDialog.Builder(this).setTitle("Please input the password!")
				.setIcon(android.R.drawable.ic_dialog_info).setView(eText)
				.setCancelable(false)
				.setPositiveButton("OK", new OnClickListener() {

					@Override
					public void onClick(DialogInterface arg0, int arg1) {
						// TODO Auto-generated method stub
						String pa = eText.getText().toString();
						if (!pa.equals("") && pa.length() == 6) {
							pDialog.show();
							sendPassword("3F" + int2Byte(pa));
						} else {
							Toast.makeText(Bluemd.this, "Password is 6 digits!",
									Toast.LENGTH_SHORT).show();
							popEditPassword();
						}
					}
				}).setNegativeButton("Quit", new OnClickListener() {

					@Override
					public void onClick(DialogInterface arg0, int arg1) {
						// TODO Auto-generated method stub
						System.exit(0);
					}
				}).create().show();
	}

	private String int2Byte(String value) {
		int va = Integer.parseInt(value);
		String hex = Integer.toHexString(va);
		int len = hex.length();
		String data = "000000";
		data = data.substring(0, 6 - len) + hex;
		String result = data.substring(4, 6) + data.substring(2, 4)
				+ data.substring(0, 2);
		return result;
	}

}