package com.tinysine.tosrblue;

import java.util.LinkedList;
import java.util.List;

import android.app.Activity;
import android.app.Application;

public class UILApplication extends Application {
	@Override
	public void onCreate() {
		super.onCreate();
	}

	private List<Activity> mList = new LinkedList<Activity>();
	private static UILApplication instance;

	public synchronized static UILApplication getInstance() {
		if (null == instance) {
			instance = new UILApplication();
		}
		return instance;
	}

	public void addActivity(Activity activity) {
		mList.add(activity);
	}

	public void exit() {
		try {
			for (Activity activity : mList) {
				if (activity != null)
					activity.finish();
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			System.exit(0);
		}
	}

	public void onLowMemory() {
		super.onLowMemory();
		System.gc();
	}
}