package com.tinysine.tosrblue.command;

import java.io.IOException;
import java.io.OutputStream;

import com.tinysine.tosrblue.io.ATConnectThread;

/**
 * 作用：从手机输出数据到蓝牙
 * 
 * 
 * */

public class ATCommandOutput extends Thread {
	private String ATcontent = null;// 指令内容
	private String ATcommandDsc = null;// 指令描述
	private String ATcommandKey = null;// 指令的代号

	private OutputStream out;
	protected ATConnectThread connectThread = null;

	public ATCommandOutput(String ATcontent, String ATcommandKey,
			String ATcommandDsc) {
		this.ATcontent = ATcontent;
		this.ATcommandDsc = ATcommandDsc;
		this.ATcommandKey = ATcommandKey;
	}

	public ATCommandOutput(ATCommandOutput other) {
		this(other.ATcontent, other.ATcommandDsc, other.ATcommandKey);
	}

	protected void sendCmd(String cmd) throws IOException {
		out.write(hexStringToBytes(cmd));
		out.flush();
	}

	// 发送指令
	public void run() {
		try {
			sendCmd(ATcontent);
		} catch (Exception e) {
		}
	}

	public String getATcommandDsc() {
		return ATcommandDsc;
	}

	public void setATcommandDsc(String aTcommandDsc) {
		ATcommandDsc = aTcommandDsc;
	}

	public String getATcommandKey() {
		return ATcommandKey;
	}

	public void setATcommandKey(String aTcommandKey) {
		ATcommandKey = aTcommandKey;
	}

	public String getATcontent() {
		return ATcontent;
	}

	public void setATcontent(String aTcontent) {
		ATcontent = aTcontent;
	}

	public OutputStream getOut() {
		return out;
	}

	public void setOut(OutputStream out) {
		this.out = out;
	}

	public CharSequence getDesc() {
		// TODO Auto-generated method stub
		return null;
	}

	public ATConnectThread getConnectThread() {
		return connectThread;
	}

	public void setConnectThread(ATConnectThread connectThread) {
		this.connectThread = connectThread;
	}

	/**
	 * 　　* Convert hex string to byte[] 　　* @param hexString the hex string 　　* @return
	 * byte[] 　　
	 */
	public byte[] hexStringToBytes(String hexString) {
		if (hexString == null || hexString.equals("")) {
			return null;
		}
		hexString = hexString.toUpperCase();
		int length = hexString.length() / 2;
		char[] hexChars = hexString.toCharArray();
		byte[] d = new byte[length];
		for (int i = 0; i < length; i++) {
			int pos = i * 2;
			d[i] = (byte) (charToByte(hexChars[pos]) << 4 | charToByte(hexChars[pos + 1]));
		}
		return d;
	}

	/**
	 * 　　* Convert char to byte 　　* @param c char 　　* @return byte 　　
	 */
	private byte charToByte(char c) {
		return (byte) "0123456789ABCDEF".indexOf(c);
	}
}
